Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QDateTime

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QDateTime

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable, java.lang.Comparable

    public class QDateTime

extends QtJambiObject
implements java.lang.Comparable, java.lang.Cloneable

The QDateTime class provides date and time functions. A QDateTime object contains a calendar date and a clock time (a "datetime"). It is a combination of the `QDate` and `QTime` classes. It can read the current datetime from the system clock. It provides functions for comparing datetimes and for manipulating a datetime by adding a number of seconds, days, months, or years.

A QDateTime object is typically created either by giving a date and time explicitly in the constructor, or by using the static function `currentDateTime()` that returns a QDateTime object set to the system clock's time. The date and time can be changed with `setDate()` and `setTime()`. A datetime can also be set using the `setTime_t()` function that takes a POSIX-standard "number of seconds since 00:00:00 on January 1, 1970" value. The `fromString()` function returns a QDateTime, given a string and a date format used to interpret the date within the string.

The `date()` and `time()` functions provide access to the date and time parts of the datetime. The same information is provided in textual format by the `toString()` function.

QDateTime provides a full set of operators to compare two QDateTime objects where smaller means earlier and larger means later.

You can increment (or decrement) a datetime by a given number of seconds using `addSecs()`, or days using `addDays()`. Similarly you can use `addMonths()` and `addYears()`. The `daysTo()` function returns the number of days between two datetimes, and `secsTo()` returns the number of seconds between two datetimes.

QDateTime can store datetimes as `local time` or as `UTC` . `QDateTime::currentDateTime()` returns a QDateTime expressed as local time; use `toUTC()` to convert it to UTC. You can also use `timeSpec()` to find out if a QDateTime object stores a UTC time or a local time. Operations such as `addSecs()` and `secsTo()` are aware of daylight saving time (DST).

Note:QDateTime does not account for leap seconds.

### Use of Gregorian and Julian Calendars

`QDate` uses the Gregorian calendar in all locales, beginning on the date 15 October 1582. For dates up to and including 4 October 1582, the Julian calendar is used. This means there is a 10-day gap in the internal calendar between the 4th and the 15th of October 1582. When you use QDateTime for dates in that epoch, the day after 4 October 1582 is 15 October 1582, and the dates in the gap are invalid.

The Julian to Gregorian changeover date used here is the date when the Gregorian calendar was first introduced, by Pope Gregory XIII. That change was not universally accepted and some localities only executed it at a later date (if at all). QDateTime doesn't take any of these historical facts into account. If an application must support a locale-specific dating system, it must do so on its own, remembering to convert the dates using the Julian day.

### No Year 0

There is no year 0. Dates in that year are considered invalid. The year -1 is the year "1 before Christ" or "1 before current era." The day before 0001-01-01 is December 31st, 1 BCE.

### Range of Valid Dates

The range of valid dates is from January 2nd, 4713 BCE, to sometime in the year 11 million CE. The Julian Day returned by `QDate::toJulianDay()` is a number in the contiguous range from 1 to overflow, even across QDateTime's "date holes". It is suitable for use in applications that must convert a QDateTime to a date in another calendar system, e.g., Hebrew, Islamic or Chinese.

The Gregorian calendar was introduced in different places around the world on different dates. QDateTime uses `QDate` to store the date, so it uses the Gregorian calendar for all locales, beginning on the date 15 October 1582. For dates up to and including 4 October 1582, QDateTime uses the Julian calendar. This means there is a 10-day gap in the QDateTime calendar between the 4th and the 15th of October 1582. When you use QDateTime for dates in that epoch, the day after 4 October 1582 is 15 October 1582, and the dates in the gap are invalid.

### Use of System Timezone

QDateTime uses the system's time zone information to determine the offset of local time from UTC. If the system is not configured correctly or not up-to-date, QDateTime will give wrong results as well.

### Daylight Savings Time (DST)

QDateTime takes into account the system's time zone information when dealing with DST. On modern Unix systems, this means it applies the correct historical DST data whenever possible. On Windows and Windows CE, where the system doesn't support historical DST data, historical accuracy is not maintained with respect to DST.

The range of valid dates taking DST into account is 1970-01-01 to the present, and rules are in place for handling DST correctly until 2037-12-31, but these could change. For dates falling outside that range, QDateTime makes a best guess using the rules for year 1970 or 2037, but we can't guarantee accuracy. This means QDateTime doesn't take into account changes in a locale's time zone before 1970, even if the system's time zone database supports that information.

See also:
  `QDate`, `QTime`, and `QDateTimeEdit`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QDateTime()` Constructs a null datetime (i.
`QDateTime(QDate arg__1)` Constructs a datetime with the given `date`, a valid time(00.00:00.
`QDateTime(QDate arg__1, QTime arg__2)` Constructs a datetime with the given `date` and `time`, using the time specification defined by `spec`.
`QDateTime(QDate arg__1, QTime arg__2, Qt.TimeSpec spec)` Constructs a datetime with the given `date` and `time`, using the time specification defined by `spec`.
`QDateTime(QDateTime other)` Constructs a copy of the `other` datetime.

Method Summary
`QDateTime` | `addDays(int days)` Returns a QDateTime object containing a datetime `ndays` days later than the datetime of this object (or earlier if `ndays` is negative).
`QDateTime` | `addMonths(int months)` Returns a QDateTime object containing a datetime `nmonths` months later than the datetime of this object (or earlier if `nmonths` is negative).
`QDateTime` | `addMSecs(long msecs)` Returns a QDateTime object containing a datetime `msecs` miliseconds later than the datetime of this object (or earlier if `msecs` is negative).
`QDateTime` | `addSecs(int secs)` Returns a QDateTime object containing a datetime `s` seconds later than the datetime of this object (or earlier if `s` is negative).
`QDateTime` | `addYears(int years)` Returns a QDateTime object containing a datetime `nyears` years later than the datetime of this object (or earlier if `nyears` is negative).
`QDateTime` | `clone()` This method is reimplemented for internal reasons
`static QDateTime` | `currentDateTime()` Returns the current datetime, as reported by the system clock, in the local time zone.
`QDate` | `date()` Returns the date part of the datetime.
`int` | `daysTo(QDateTime arg__1)` Returns the number of days from this datetime to the `other` datetime.
`static QDateTime` | `fromString(java.lang.String s)` Returns the QDateTime represented by the `string`, using the `format` given, or an invalid datetime if this is not possible.
`static QDateTime` | `fromString(java.lang.String s, Qt.DateFormat f)` Returns the QDateTime represented by the `string`, using the `format` given, or an invalid datetime if this is not possible.
`static QDateTime` | `fromString(java.lang.String s, java.lang.String format)` Returns the QDateTime represented by the `string`, using the `format` given, or an invalid datetime if the string cannot be parsed.
`static QDateTime` | `fromTime_t(int secsSince1Jan1970UTC)` Returns a datetime whose date and time are the number of `seconds` that have passed since 1970-01-01T00.00:00, Coordinated Universal Time (`Qt::UTC` ).
`boolean` | `isNull()` Returns true if both the date and the time are null; otherwise returns false.
`boolean` | `isValid()` Returns true if both the date and the time are valid; otherwise returns false.
`void` | `readFrom(QDataStream arg__1)` Reads a QDateTime
`int` | `secsTo(QDateTime arg__1)` Returns the number of seconds from this datetime to the `other` datetime.
`void` | `setDate(QDate date)` Sets the date part of this datetime to `date`.
`void` | `setTime_t(int secsSince1Jan1970UTC)` Sets the date and time given the number of `seconds` that have passed since 1970-01-01T00.00:00, Coordinated Universal Time (`Qt::UTC` ).
`void` | `setTime(QTime time)` Sets the time part of this datetime to `time`.
`void` | `setTimeSpec(Qt.TimeSpec spec)` Sets the time specification used in this datetime to `spec`.
`QTime` | `time()` Returns the time part of the datetime.
`Qt.TimeSpec` | `timeSpec()` Returns the time specification of the datetime.
`QDateTime` | `toLocalTime()` Returns a datetime containing the date and time information in this datetime, but specified using the `Qt::LocalTime` definition.
`java.lang.String` | `toString()` Returns a string representation of the `this QDateTime`.
`java.lang.String` | `toString(Qt.DateFormat f)` Returns a string representation of the `com.trolltech.qt.core.Qt$DateFormat` argument.
`java.lang.String` | `toString(java.lang.String format)` Returns a string representation of the `java.lang.String` argument.
`int` | `toTime_t()` Returns the datetime as the number of seconds that have passed since 1970-01-01T00.00:00, Coordinated Universal Time (`Qt::UTC` ).
`QDateTime` | `toTimeSpec(Qt.TimeSpec spec)` Returns a copy of this datetime configured to use the given time `specification`.
`QDateTime` | `toUTC()` Returns a datetime containing the date and time information in this datetime, but specified using the `Qt::UTC` definition.
`void` | `writeTo(QDataStream arg__1)` Writes thisQDateTime

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.lang.Comparable
`compareTo`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QDateTime

    public QDateTime()

  Constructs a null datetime (i. . null date and null time). A null datetime is invalid, since the date is invalid.

See also:
  `isValid()`.

### QDateTime

    public QDateTime(QDate arg__1)

  Constructs a datetime with the given `date`, a valid time(00.00:00. 00), and sets the `timeSpec()` to `Qt::LocalTime` .

### QDateTime

    public QDateTime(QDate arg__1,
                     QTime arg__2)

  Constructs a datetime with the given `date` and `time`, using the time specification defined by `spec`.

  If `date` is valid and `time` is not, the time will be set to midnight.

### QDateTime

    public QDateTime(QDate arg__1,
                     QTime arg__2,
                     Qt.TimeSpec spec)

  Constructs a datetime with the given `date` and `time`, using the time specification defined by `spec`.

  If `date` is valid and `time` is not, the time will be set to midnight.

### QDateTime

    public QDateTime(QDateTime other)

  Constructs a copy of the `other` datetime.

Method Detail

### addDays

    public final QDateTime addDays(int days)

  Returns a QDateTime object containing a datetime `ndays` days later than the datetime of this object (or earlier if `ndays` is negative).

See also:
  `daysTo()`, `addMonths()`, `addYears()`, and `addSecs()`.

### addMSecs

    public final QDateTime addMSecs(long msecs)

  Returns a QDateTime object containing a datetime `msecs` miliseconds later than the datetime of this object (or earlier if `msecs` is negative).

See also:
  `addSecs()`, `secsTo()`, `addDays()`, `addMonths()`, and `addYears()`.

### addMonths

    public final QDateTime addMonths(int months)

  Returns a QDateTime object containing a datetime `nmonths` months later than the datetime of this object (or earlier if `nmonths` is negative).

See also:
  `daysTo()`, `addDays()`, `addYears()`, and `addSecs()`.

### addSecs

    public final QDateTime addSecs(int secs)

  Returns a QDateTime object containing a datetime `s` seconds later than the datetime of this object (or earlier if `s` is negative).

See also:
  `addMSecs()`, `secsTo()`, `addDays()`, `addMonths()`, and `addYears()`.

### addYears

    public final QDateTime addYears(int years)

  Returns a QDateTime object containing a datetime `nyears` years later than the datetime of this object (or earlier if `nyears` is negative).

See also:
  `daysTo()`, `addDays()`, `addMonths()`, and `addSecs()`.

### date

    public final QDate date()

  Returns the date part of the datetime.

See also:
  `setDate()`, `time()`, and `timeSpec()`.

### daysTo

    public final int daysTo(QDateTime arg__1)

  Returns the number of days from this datetime to the `other` datetime. If the `other` datetime is earlier than this datetime, the value returned is negative.

See also:
  `addDays()`, and `secsTo()`.

### isNull

    public final boolean isNull()

  Returns true if both the date and the time are null; otherwise returns false. A null datetime is invalid.

See also:
  `QDate::isNull()`, `QTime::isNull()`, and `isValid()`.

### isValid

    public final boolean isValid()

  Returns true if both the date and the time are valid; otherwise returns false.

See also:
  `QDate::isValid()`, and `QTime::isValid()`.

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQDateTime

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QDateTime

### secsTo

    public final int secsTo(QDateTime arg__1)

  Returns the number of seconds from this datetime to the `other` datetime. If the `other` datetime is earlier than this datetime, the value returned is negative.

  Before performing the comparison, the two datetimes are converted to `Qt::UTC` to ensure that the result is correct if one of the two datetimes has daylight saving time (DST) and the other doesn't.

  Example:

              QDateTime now = QDateTime.currentDateTime();
              QDateTime xmas = new QDateTime(new QDate(now.date().year(), 12, 25), new QTime(0, 0));
              System.err.println("There are " + now.secsTo(xmas) + "seconds to Christmas");

See also:
  `addSecs()`, `daysTo()`, and `QTime::secsTo()`.

### setDate

    public final void setDate(QDate date)

  Sets the date part of this datetime to `date`. If no time is set, it is set to midnight.

See also:
  `date()`, `setTime()`, and `setTimeSpec()`.

### setTime

    public final void setTime(QTime time)

  Sets the time part of this datetime to `time`.

See also:
  `time()`, `setDate()`, and `setTimeSpec()`.

### setTimeSpec

    public final void setTimeSpec(Qt.TimeSpec spec)

  Sets the time specification used in this datetime to `spec`.

See also:
  `timeSpec()`, `setDate()`, `setTime()`, and `Qt::TimeSpec` .

### setTime_t

    public final void setTime_t(int secsSince1Jan1970UTC)

  Sets the date and time given the number of `seconds` that have passed since 1970-01-01T00.00:00, Coordinated Universal Time (`Qt::UTC` ). On systems that do not support time zones this function will behave as if local time were `Qt::UTC` .

See also:
  `toTime_t()`.

### time

    public final QTime time()

  Returns the time part of the datetime.

See also:
  `setTime()`, `date()`, and `timeSpec()`.

### timeSpec

    public final Qt.TimeSpec timeSpec()

  Returns the time specification of the datetime.

See also:
  `setTimeSpec()`, `date()`, `time()`, and `Qt::TimeSpec` .

### toLocalTime

    public final QDateTime toLocalTime()

  Returns a datetime containing the date and time information in this datetime, but specified using the `Qt::LocalTime` definition.

See also:
  `toTimeSpec()`.

### toString

    public final java.lang.String toString()

  Returns a string representation of the `this QDateTime`.

  Overrides:
    `toString` in class `java.lang.Object`

### toString

    public final java.lang.String toString(Qt.DateFormat f)

  Returns a string representation of the `com.trolltech.qt.core.Qt$DateFormat` argument.

### toString

    public final java.lang.String toString(java.lang.String format)

  Returns a string representation of the `java.lang.String` argument.

### toTimeSpec

    public final QDateTime toTimeSpec(Qt.TimeSpec spec)

  Returns a copy of this datetime configured to use the given time `specification`.

See also:
  `timeSpec()`, `toUTC()`, and `toLocalTime()`.

### toTime_t

    public final int toTime_t()

  Returns the datetime as the number of seconds that have passed since 1970-01-01T00.00:00, Coordinated Universal Time (`Qt::UTC` ).

  On systems that do not support time zones, this function will behave as if local time were `Qt::UTC` .

See also:
  `setTime_t()`.

### toUTC

    public final QDateTime toUTC()

  Returns a datetime containing the date and time information in this datetime, but specified using the `Qt::UTC` definition.

See also:
  `toTimeSpec()`.

### currentDateTime

    public static QDateTime currentDateTime()

  Returns the current datetime, as reported by the system clock, in the local time zone.

See also:
  `QDate::currentDate()`, `QTime::currentTime()`, and `toTimeSpec()`.

### fromString

    public static QDateTime fromString(java.lang.String s)

  Returns the QDateTime represented by the `string`, using the `format` given, or an invalid datetime if this is not possible.

  Note for `Qt::TextDate` : It is recommended that you use the English short month names (e.g. "Jan"). Although localized month names can also be used, they depend on the user's locale settings.

### fromString

    public static QDateTime fromString(java.lang.String s,
                                       Qt.DateFormat f)

  Returns the QDateTime represented by the `string`, using the `format` given, or an invalid datetime if this is not possible.

  Note for `Qt::TextDate` : It is recommended that you use the English short month names (e.g. "Jan"). Although localized month names can also be used, they depend on the user's locale settings.

### fromString

    public static QDateTime fromString(java.lang.String s,
                                       java.lang.String format)

  Returns the QDateTime represented by the `string`, using the `format` given, or an invalid datetime if the string cannot be parsed.

  These expressions may be used for the date part of the format string:

  Expression | Output
  --- | ---
  d | the day as number without a leading zero (1 to 31)
  dd | the day as number with a leading zero (01 to 31)
  ddd | the abbreviated localized day name (e.g. 'Mon' to 'Sun'). Uses `QDate::shortDayName()`.
  dddd | the long localized day name (e.g. 'Monday' to 'Sunday'). Uses `QDate::longDayName()`.
  M | the month as number without a leading zero (1-12)
  MM | the month as number with a leading zero (01-12)
  MMM | the abbreviated localized month name (e.g. 'Jan' to 'Dec'). Uses `QDate::shortMonthName()`.
  MMMM | the long localized month name (e.g. 'January' to 'December'). Uses `QDate::longMonthName()`.
  yy | the year as two digit number (00-99)
  yyyy | the year as four digit number

  Note: Unlike the other version of this function, day and month names must be given in the user's local language. It is only possible to use the English names if the user's language is English.

  These expressions may be used for the time part of the format string:

  Expression | Output
  --- | ---
  h | the hour without a leading zero (0 to 23 or 1 to 12 if AM/PM display)
  hh | the hour with a leading zero (00 to 23 or 01 to 12 if AM/PM display)
  H | the hour without a leading zero (0 to 23, even with AM/PM display)
  HH | the hour with a leading zero (00 to 23, even with AM/PM display)
  m | the minute without a leading zero (0 to 59)
  mm | the minute with a leading zero (00 to 59)
  s | the second without a leading zero (0 to 59)
  ss | the second with a leading zero (00 to 59)
  z | the milliseconds without leading zeroes (0 to 999)
  zzz | the milliseconds with leading zeroes (000 to 999)
  AP or A | interpret as an AM/PM time. AP must be either "AM" or "PM".
  ap or a | Interpret as an AM/PM time. ap must be either "am" or "pm".

  All other input characters will be treated as text. Any sequence of characters that are enclosed in singlequotes will also be treated as text and not be used as an expression.

              QTime time1 = QTime.fromString("131", "HHh");
              // time1 is 13:00:00
              QTime time2 = QTime.fromString("1apA", "1amAM");
              // time1 is 01:00:00

              QDateTime dateTime2 = QDateTime.fromString("M1d1y9800:01:02",
                                                          "'M'M'd'd'y'yyhh:mm:ss");
              // dateTime is 1 January 1998 00:01:02

  If the format is not satisfied an invalid QDateTime is returned. The expressions that don't have leading zeroes (d, M, h, m, s, z) will be greedy. This means that they will use two digits even if this will put them outside the range and/or leave too few digits for other sections.

              QDateTime dateTime = QDateTime.fromString("130", "Mm"); // invalid

  This could have meant 1 January 00:30.00 but the M will grab two digits.

  For any field that is not represented in the format the following defaults are used:

  Field | Default value
  --- | ---
  Year | 1900
  Month | 1 (January)
  Day | 1
  Hour | 0
  Minute | 0
  Second | 0

  For example:

              QDateTime dateTime = QDateTime.fromString("1.30.1", "M.d.s");
              // dateTime is January 30 in the current year 00:00:01

  `QDateTime::toString()``QTime::toString()`

See also:
  `QDate::fromString()`, `QTime::fromString()`, and `QDate::toString()`.

### fromTime_t

    public static QDateTime fromTime_t(int secsSince1Jan1970UTC)

  Returns a datetime whose date and time are the number of `seconds` that have passed since 1970-01-01T00.00:00, Coordinated Universal Time (`Qt::UTC` ). On systems that do not support time zones, the time will be set as if local time were `Qt::UTC` .

See also:
  `toTime_t()`, and `setTime_t()`.

### clone

    public QDateTime clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD